/*
    CVad Channel Occupancy Detection Library Project Code
    Copyright (C) 2007-2015 Charles Brain, G4GUO and Steve Hajducek, N2CKH

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#pragma once

class CVad
{
private:
	enum{ ANAL_START = 4, ANAL_END = 20 };
	enum{ ANAL_SIZE = 160 };
	float    m_mags[1000];// Large enough for this
	float    m_max_difs;
	float    m_difs_thresh;
	int      m_active;
	int      m_sample_clk;
	int      m_fft_length;
private:
	float calc_differences( float *in );
	void  update_mags( float *in );
	void  reset_mags( void );
	void  restart( void );
public:
	void  Start( void );
	int   Stop( void );
	void  SetThreshold( float threshold );
	void  SetFftLength( int size );
	float GetLevel(void);
	int   GetFinalDecision( void );
	void  Input( float *samples );
	CVad(void);
	~CVad(void);
};
