
/*
    CVad Channel Occupancy Detection Library Project Code
    Copyright (C) 2007-2015 Charles Brain, G4GUO and Steve Hajducek, N2CKH

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "StdAfx.h"
#include ".\vad.h"
#define _USE_MATH_DEFINES
#include "math.h"
#include "memory.h"

void CVad::update_mags( float *in )
{
	for( int i = 0; i < m_fft_length/2; i++ ) 
	{
		m_mags[i] += in[i];
	}
}
void CVad::reset_mags( void )
{
	memset( m_mags, 0, sizeof(float)*m_fft_length/2);
}

//
// Find the variation of the magnitudes
//
float CVad::calc_differences( float *in )
{
	float min;
	float sum;
	// find the lowest magnitude
	min = in[ANAL_START];
	for( int i = ANAL_START; i < ANAL_END; i++ )
	{
		if(in[i] < min ) min = in[i];
	}
	// now sum the differences
	sum = 0;
	for( int i = ANAL_START; i < ANAL_END; i++ )
	{
		sum += fabs( in[i] - min );
	}
	// Normalise the result
	sum = sum/min;
	return sum;
}
int CVad::GetFinalDecision( void )
{
	if( m_max_difs > m_difs_thresh )
		return 1;
	else
		return 0;
}
